=== debian/changelog ===
ogre-next (2.2.5+dfsg3-0ubuntu2) jammy; urgency=medium

  * Enable SIMD only in amd64 to fix ppc64el, riscv64, s390x
    (LP: #1961319)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 17 Feb 2022 16:12:56 +0000

ogre-next (2.2.5+dfsg3-0ubuntu1) jammy; urgency=medium

  * Initial release (LP: #1960149)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 09 Dec 2021 19:09:45 +0000
