=== debian/control ===
Source: ogre-next
Maintainer: Ubuntu developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               chrpath,
               cmake,
               pkg-config,
               libboost-dev,
               libboost-atomic-dev,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcppunit-dev,
               libglu1-mesa-dev,
               libgl1-mesa-dev,
               libgles2-mesa-dev,
               libfreeimage-dev,
               libfreetype6-dev,
               libois-dev [linux-any],
               libpoco-dev,
               libtbb-dev,
               libtinyxml-dev,
               libxrandr-dev,
               libxxf86vm-dev,
               libxaw7-dev,
               libxt-dev,
               libz-dev,
               libzzip-dev,
               rapidjson-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texinfo
Standards-Version: 4.6.0
Vcs-Browser: https://github.com/OGRECave/ogre-next
Vcs-Git: https://github.com/OGRECave/ogre-next.git
Rules-Requires-Root: no
Homepage: https://github.com/OGRECave/ogre-next

Package: libogre-next-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libboost-dev,
         libboost-thread-dev,
         libogrenexthlmspbs2.2.5 (= ${binary:Version}),
         libogrenexthlmsunlit2.2.5 (= ${binary:Version}),
         libogrenextmain2.2.5 (= ${binary:Version}),
         libogrenextmeshlodgenerator2.2.5 (= ${binary:Version}),
         libogrenextoverlay2.2.5 (= ${binary:Version}),
         libogrenextplanarreflections2.2.5 (= ${binary:Version}),
         libogrenextsceneformat2.2.5 (= ${binary:Version})
Suggests: ogre-next-doc
Description: 3D Object-Oriented Graphics Rendering Engine (development files)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the headers needed to develop with OGRE-Next.

Package: libogrenexthlmspbs2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - hlmspbs
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenexthlmspbs.

Package: libogrenexthlmsunlit2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - hlmsunlit
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenexthlmsunlit.

Package: libogrenextmain2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - Main lib+plugins
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenextmain and the plugins and rendering
 systems.

Package: libogrenextmeshlodgenerator2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - meshlodgenerator
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenextmeshlodgenerator.

Package: libogrenextoverlay2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - overlay
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenextoverlay.

Package: libogrenextplanarreflections2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - planarreflections
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenextplanarreflections.

Package: libogrenextsceneformat2.2.5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine - sceneformat
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 The package name includes all the version number on it. The reason for that
 is that upstream does not guarantee ABI stability even on patches. For more
 information check the README.Debian file section 'ABI policy upstream'.
 .
 This package contains the library libogrenextsceneformat.

Package: ogre-next-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery
Description: 3D Object-Oriented Graphics Rendering Engine (documentation)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the documentation.

Package: ogre-next-tools
Section: devel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D Object-Oriented Graphics Rendering Engine (tools)
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains tools used to convert from and to OGRE's native mesh
 format.

Package: blender-ogrexml-next
Section: graphics
Architecture: all
Depends: ${misc:Depends},
         blender
Conflicts: blender-ogrexml
Description: Blender Exporter for OGRE-Next
 OGRE (Object-Oriented Graphics Rendering Engine) is a scene-oriented, flexible
 3D engine written in C++ designed to make it easier and more intuitive for
 developers to produce applications utilising hardware-accelerated 3D
 graphics. The class library abstracts all the details of using the underlying
 system libraries like Direct3D and OpenGL and provides an interface based on
 world objects and other intuitive classes.
 .
 This package contains the Blender exporter for OGRE-Next.
